/////////////////////////////////////////////////////////////////////
//Bildschirmschoner: Erzeugung von Sternen nach Maßgabe von logarithmischen
//Durchschnitts-Amplituden der Frequenzbänder.
//Band 0 : Größe (getrennt rechter/linker Kanal)
//Bänder 1,2 und 3: Farbe (gemeinsamer Kanal)
//Bänder 4 und 5: Ort (getrennt rechter/linker Kanal)
//////////////////////////////////////////////////////////////////////
import shiffman.box2d.*;
import org.jbox2d.collision.shapes.*;
import org.jbox2d.common.*;
import org.jbox2d.dynamics.*;
import ddf.minim.*;
import ddf.minim.analysis.*;

Box2DProcessing box2d;  
Minim minim;
AudioPlayer musik;
FFT fft;
float rot,gruen,blau;
int x,y,xl,yl,xr,yr;
float xf,yf;
float groesseL,groesseR;//Größe der Sterne links und rechts
int i,w,h;
ArrayList<Stern> sterne;
color c; //Farbe der Sterne
	
void setup() {
  fullScreen();  
  //size(800,800);
  smooth();
  background(0);
  noStroke();
  
  // Die Physik-Welt in Box2D initalisieren
  box2d = new Box2DProcessing(this);	
  //...und erzeugen
  box2d.createWorld();
  box2d.setGravity(0,-10);
  sterne = new ArrayList<Stern>(); 
  // Vorbereitung für Steuerung durch Musik
  x = y = 0;
  xl = yl = 0;
  xr = yr = 0;
  xf = yf = 0.0;
  
  rot = gruen = blau =0;
  groesseL = groesseR =0.5;
  
  i=0;w=0;h=0;
   
  minim = new Minim (this);
  musik = minim.loadFile ("musik.mp3");
 
  musik.play (); 
  // FFT-Objekt für lineare FT des Buffers
  fft = new FFT (musik.bufferSize (), 
                 musik.sampleRate ()); //musik.bufferSize: 1024 ,musik.sampleRate: 44100 
  //fft.specSize() = 513;
  fft.logAverages( 380, 1 );//6
}

void draw() {
  background(0);  
  // Zeitschritt
  box2d.step();    
  //Nächster Puffer Mitte
  fft.forward (musik.mix); 
  //Farbe bestimmen
  rot=fft.getAvg(1)*40;
  gruen=fft.getAvg(2)*60;
  blau=fft.getAvg(3)*80;
  //----------------------------------------------------
  //Nächster Puffer linker Kanal
  fft.forward (musik.left);
  xf = fft.getAvg(4)*width*6;
  yf = fft.getAvg(5)*height*6;
 
  if(xf<= width/2 && xf>=50){ 
    xl=width/2-int(xf);}else{xl=int(random(50,width/2));}
   
  if(yf<=height *0.7 ) { 
    yl=int(yf);}else{yl= int(random(50,height/2));}
  
  if(fft.getAvg(0)>= 10) {
     groesseL = 2.5;
   }else if(fft.getAvg(0)<=1){
     groesseL = 0.25;
   }else {groesseL=fft.getAvg(0)*0.25;}    
  //---------------------------------------------------- 
  //Nächster Puffer rechter Kanal  
  fft.forward (musik.right);
  xf = fft.getAvg(4)*width*6;
  yf = fft.getAvg(5)*height*6;
  
  if(xf>= width/2 && xf<=width-50){ 
    xr=int(xf);}else{xr=int(random(width/2,width-50));}
    
  if(yf<=height *0.9) { 
    yr=int(yf);}else{yr= int(random(50,height/2));}
    
  if(fft.getAvg(0)>= 10) {
     groesseR = 2.5;
   }else if(fft.getAvg(0)<=1){
     groesseR = 0.25;
   }else {groesseR=fft.getAvg(0)*0.25;}
  //---------------------------------------------------------- 
  //Sterne erzeugen und anzeigen
  c= color(rot,gruen,blau);
  //Anzahl der erzeugten Sterne pro Zeit abhängig von Bildschirmhöhe
  if(random(1)<height*0.0001){
  Stern sternL = new Stern(xl,yl,c,groesseL);
      sterne.add(sternL); 
  Stern sternR = new Stern(xr,yr,c,groesseR);
      sterne.add(sternR); 
  }
  // Alle Sterne anzeigen
  for (Stern sT: sterne) {
    sT.display();
  }
}